<template>
  <div div="user">
    <b-jumbotron>
      <template slot="header">Criterion creation form</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>
      <b-form @submit.stop.prevent="onSubmit">
        <b-form-group id="name-input-group" label="Name" label-for="name-input">
          <b-form-input
            id="name-input"
            name="name-input"
            v-model="$v.form.name.$model"
            :state="$v.form.name.$dirty ? !$v.form.name.$error : null"
            aria-describedby="name-input-live-feedback"
          ></b-form-input>

          <b-form-invalid-feedback id="name-input-live-feedback">Name should not be empty.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="mark-mode-input-group" label="Mark Mode" label-for="mark-mode-input">
          <b-form-select
            id="mark-mode-input"
            name="mark-mode-input"
            v-model="$v.form.markMode.$model"
            :options="modes"
            :state="$v.form.markMode.$dirty ? !$v.form.markMode.$error : null"
            aria-describedby="mark-mode-live-feedback"
          ></b-form-select>

          <b-form-invalid-feedback id="mark-mode-live-feedback">This is a required field.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="mark-match-input-group" label="Mark Match" label-for="mark-match-input">
          <b-form-select
            id="mark-match-input"
            name="mark-match-input"
            v-model="$v.form.markMatch.$model"
            :options="matches"
            :state="$v.form.markMatch.$dirty ? !$v.form.markMatch.$error : null"
            aria-describedby="mark-match-live-feedback"
          ></b-form-select>

          <b-form-invalid-feedback id="mark-match-live-feedback">This is a required field.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="mark-input-group" label="Mark " label-for="mark-input">
          <b-form-input
            id="mark-input"
            name="mark-input"
            v-model="$v.form.mark.$model"
            :state="$v.form.mark.$dirty ? !$v.form.mark.$error : null"
            aria-describedby="mark-live-feedback"
          ></b-form-input>

          <b-form-invalid-feedback
            id="mark-live-feedback"
          >Mark should be non-negative integer below 102 (except for total).</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group
          id="attempts-mode-input-group"
          label="Attempts Mode"
          label-for="attempts-mode-input"
        >
          <b-form-select
            id="attempts-mode-input"
            name="attempts-mode-input"
            v-model="$v.form.attemptsMode.$model"
            :options="modes"
            :state="$v.form.attemptsMode.$dirty ? !$v.form.attemptsMode.$error : null"
            aria-describedby="attempts-mode-live-feedback"
          ></b-form-select>

          <b-form-invalid-feedback id="attempts-mode-live-feedback">This is a required field.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group
          id="attempts-match-input-group"
          label="Attempts Match"
          label-for="attempts-match-input"
        >
          <b-form-select
            id="attempts-match-input"
            name="attempts-match-input"
            v-model="$v.form.attemptsMatch.$model"
            :options="matches"
            :state="$v.form.attemptsMatch.$dirty ? !$v.form.attemptsMatch.$error : null"
            aria-describedby="attempts-match-live-feedback"
          ></b-form-select>

          <b-form-invalid-feedback id="attempts-match-live-feedback">This is a required field.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="attempts-input-group" label="Attempts" label-for="attempts-input">
          <b-form-input
            id="attempts-input"
            name="attempts-input"
            v-model="$v.form.attempts.$model"
            :state="$v.form.attempts.$dirty ? !$v.form.attempts.$error : null"
            aria-describedby="attempts-live-feedback"
          ></b-form-input>

          <b-form-invalid-feedback
            id="attempts-live-feedback"
          >Attempts should be non-negative integer.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="exams-input-group" label="Exams" label-for="exams-input">
          <b-form-select
            id="exams-input"
            name="exams-input"
            v-model="$v.form.requireExams.$model"
            :options="exams"
            :state="$v.form.requireExams.$dirty ? !$v.form.requireExams.$error : null"
            aria-describedby="exams-live-feedback"
          ></b-form-select>

          <b-form-invalid-feedback id="exams-live-feedback">This is a required field.</b-form-invalid-feedback>
        </b-form-group>

        <b-button type="submit" variant="primary" :disabled="$v.form.$invalid">Submit</b-button>
      </b-form>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";
import { validationMixin } from "vuelidate";
import {
  required,
  minLength,
  minValue,
  integer
} from "vuelidate/lib/validators";

export default {
  name: "NewCriterion",
  mixins: [validationMixin],
  data() {
    return {
      modes: ["None", "Once", "All", "Average", "Total"],
      matches: ["Below", "Above", "Equal"],
      exams: ["Only subject with exams", "Any subject"],
      form: {
        name: null,
        markMode: null,
        markMatch: null,
        mark: null,
        attemptsMode: null,
        attemptsMatch: null,
        attempts: null,
        requireExams: null
      },
      alertMessage: "Request error",
      hasError: false
    };
  },
  validations: {
    form: {
      name: {
        required,
        minLength: minLength(1)
      },
      markMode: {
        required
      },
      markMatch: {
        required
      },
      mark: {
        required,
        integer,
        minVaue: minValue(0)
      },
      attemptsMode: {
        required
      },
      attemptsMatch: {
        required
      },
      attempts: {
        required,
        integer,
        minVaue: minValue(0)
      },
      requireExams: {
        required
      }
    }
  },
  methods: {
    dispatchToCriterion(name) {
      this.$router.push({ name: "Criterion", params: { criterionName: name } });
    },
    postData() {
      this.$data.form.requireExams =
        this.$data.form.requireExams === "Only subject with exams";
      AXIOS.post(`/edu/criteria/new`, this.$data.form, {
        withCredentials: true
      })
        .then(
          response => {
            console.log(response);
            this.hasError = false;
            this.dispatchToCriterion(this.$data.form.name);
          },
          error => {
            this.$data.form.requireExams = this.$data.form.requireExams
              ? "Only subject with exams"
              : "Any subject";
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            console.log(error);
          }
        )
        .catch(e => {
          this.$data.form.requireExams = this.$data.form.requireExams
            ? "Only subject with exams"
            : "Any subject";
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.hasError = true;
        });
    },
    onSubmit() {
      this.$v.form.$touch();
      if (this.$v.form.$anyError) {
        console.log(this.$v.form);
        console.log(this.$data.form);
        return;
      }

      this.postData();
    }
  }
};
</script>